/*Maeyeda's 2-tree method to evaluate topological formulas using
(Minty's algorithm for spanning tree enumeration
in Symbolic Network Analysis, Lin) */

#include <stdio.h>
#define ACTMAX 10 /* max active 4-ports */
#define EMAX (40+ACTMAX)   /* max edges */
#define NMAX 20  /* max nodes */
#define STK1 NMAX  /* minty alg. stack */
#define STK2 NMAX  /* traverse stack */
#define VTREE 1
#define ITREE 2
char trace[EMAX][EMAX];
char treebuf[EMAX+NMAX][NMAX];
char treebufd1[EMAX+NMAX][NMAX];
char treebufd2[EMAX+NMAX][NMAX];
char treesign[EMAX+NMAX];
int nbuf;

main()
{
int e,n,r,a,act,d1[EMAX],d2[EMAX],d3[ACTMAX],d4[ACTMAX],v[NMAX],edge[EMAX],vstk[STK1][NMAX],
   estk[STK1][EMAX],tree[NMAX],vd1,vd2,i,j,scan;
char branch[EMAX][8];
/* scanf("%u %u",&e,&n); */
nbuf = 0;
e = 1; /* first edge is always dummy */
n = 0;
a = 0;
act = 0;
scan = 1;
do{
/*printf("scanloop e= %d\r\n",e);*/
scanf("%s,%u,%u",&branch[e+1][0],&d1[e+1],&d2[e+1]);
/*printf("%s,%u,%u\n\r",&branch[e+1][0],d1[e+1],d2[e+1]);*/
if ( (branch[e+1][0] != 'x') && (branch[e+1][0] != 'X') ) {
if ( (branch[e+1][0] == 'k') || (branch[e+1][0] == 'K') ||
     (branch[e+1][0] == 'm') || (branch[e+1][0] == 'M') ||
     (branch[e+1][0] == 'f') || (branch[e+1][0] == 'F') ) {
scanf(",%u,%u",&d3[a+1],&d4[a+1]);
e++;
if ( d1[e] > n ) n = d1[e];
if ( d2[e] > n ) n = d2[e];
a++;
if ( d3[a] > n ) n = d3[a];
if ( d4[a] > n ) n = d4[a];
}
else
{
e++;
if ( d1[e] > n ) n = d1[e];
if ( d2[e] > n ) n = d2[e];
}
} else {
/* dummy edge (handle) and extra node */
d1[1] = n+1;
d2[1] = 1;
branch[1][0] = 'X';
branch[1][1] = 0;
n++;
scan = 0;
};
} while (scan == 1);
printf("e= %d, a=%d, n=%d\n",e ,a ,n);
for(i=1;i<=e-a;i++){
printf("%s,%d,%d\n",&branch[i][0],d1[i],d2[i]);
};
for(i=1;i<=a;i++){
printf("%s,%d,%d,%d,%d\n",&branch[i+e-a][0],d1[i+e-a],d2[i+e-a],d3[i],d4[i]);
};
e = e - a;
r = n - 1;
printf("Spanning Tree Admittance Products:\n");
/*printf(" Function: \n\r");
printf(" Numerator: \n\r");  */
printf(" V-tree: \n");
setup_trace(e,a, d1, d2, trace);
minty(n,(e+a),r,&d1,&d2,&v,&vstk,&estk,&edge,*tree,branch,e,VTREE);
printf(" I-tree: \n");
for(i=1;i<=a;i++){
j = d1[e+i]; d1[e+i] = d3[i]; d3[i] = j;
j = d2[e+i]; d2[e+i] = d4[i]; d4[i] = j;
};
setup_trace(e,a, d1, d2, trace);
minty(n,(e+a),r,&d1,&d2,&v,&vstk,&estk,&edge,*tree,branch,e,ITREE);
return;
printf(" Denominator: \n");
for(i=1;i<=a;i++){
j = d1[e+i]; d1[e+i] = d3[i]; d3[i] = j;
j = d2[e+i]; d2[e+i] = d4[i]; d4[i] = j;
};
minty(n,e,r,&d1,&d2,&v,&vstk,&estk,&edge,*tree,branch);
printf(" End: \n\r");
}

print_tree(r,sign,tree,branch)
int r,sign,tree[];
char branch[][8];
{
int s,i;
s = 0;
for(i = 1;i <= r;i++) {
if ( branch[tree[i]][0] == 'c' ) s++;
if ( branch[tree[i]][0] == 'C' ) s++;
if ( branch[tree[i]][0] == 'l' ) s--;
if ( branch[tree[i]][0] == 'L' ) s--;
}
printf("%s s%d",(sign == 1)?"-":"+",s);
for(i = 1;i <= r;i++) {
printf(" %s",&branch[tree[i]][0]);
}
printf("\n");
}

void setup_trace(pe,ae,d1,d2,tr)
int pe, ae, d1[], d2[];
char tr[][EMAX];
{
int i,j;
for(i = 1; i <= pe+ae ; i++){
  for(j = 1; j <= pe+ae ; j++){
    if( ( (d1[i] != d1[j]) && (d1[i] != d2[j])
          && (d2[i] != d1[j]) && (d2[i] != d2[j]) ) ||
          ((d1[i] == d1[j]) && (d2[i] == d2[j])) ||
          ((d1[i] == d2[j]) && (d2[i] == d1[j]))   ){
          tr[i][j] = 0;
          }
          else
          {
          if( ((d1[i] == d1[j]) || (d2[i] == d1[j])) ||
              (j <= pe) ) {
            tr[i][j] = 1;
            }
            else
            tr[i][j] = -1;
          }
  };
};
/* for(i = 1; i <= pe+ae ; i++){
  for(j = 1; j <= pe+ae ; j++){
  printf("%2d ",tr[i][j]);
  };
printf("\n");
};
*/
}

int treecheck(r,tree,d1,d2)
int r,tree[],d1[],d2[];
{
char stack1[STK2], stack2[STK2],tag[NMAX];
int depth,i,j,sign,cur_edge,nxt_edge;
/* printf("treecheck, r=%d\n",r); */
for(i=1; i<=r;i++){
tag[i] = 0;
/*printf("%d ",tree[i]);*/
};
/*printf("\n");*/
sign = 1;
for(i=1; i<=r;i++){
 if((d1[tree[i]] == 1) || (d2[tree[i]] == 1) ){
 stack1[0] = tree[i];
 stack2[0] = 1;
 depth = 1;
 break;
 };
};
for(;(depth > 0);){
/* sign = sign*(-1);*/
  depth--;
  cur_edge = stack1[depth];
  nxt_edge = stack2[depth];
/* printf("cur_edge,nxt_edge,depth=%d %d %d\n",cur_edge,nxt_edge,depth);*/
  for(i=nxt_edge;i<=r;i++){
/*  printf("i,tree[i],tag[i],trace[cur_edge][tree[i]],sign =%d %d %d %d %d\n",
          i,tree[i],tag[i],trace[cur_edge][tree[i]],sign ); */
    if(tree[i] == cur_edge) continue;
    if(tag[i] != 0) continue;
    /*if(tree[i] < nxt_edge) continue;*/
    if(trace[cur_edge][tree[i]] == 0) {/*sign = sign*(-1)*/; continue;};/* structural sign adjustment? */
    tag[i] = 1;
    if((int)trace[cur_edge][tree[i]] == 255) {/*printf("reverse sign\n");*/sign = sign*(-1); };
    stack1[depth] = cur_edge;
    stack2[depth] = i+1;
    depth++;
    stack1[depth] = tree[i];
    stack2[depth] = 1;
    depth++;
    break;
  };
if((depth >= (STK2-2)) ){printf("stack runaway\n\r");return(0);};
};
return(sign);
}


void product(r,tree,branch,d1,d2,pe,pass)
int r,pass,pe,d1[],d2[],tree[];
char branch[][8];
{
int i,j,k,m,n,s,sign,tmp;
switch (pass){
case VTREE:
  if(tree[r-1] > pe){
  for(i=1; i < r; i++){
  treebuf[nbuf][i] = tree[i];
  treebufd1[nbuf][i] = d1[tree[i]];
  treebufd2[nbuf][i] = d2[tree[i]];
  };
  treesign[nbuf] = (treecheck(r-1,tree,d1,d2) == 1)?1:-1;
  nbuf++;
  printf("buffered Vtree:\n");
print_tree(r-1,treesign[nbuf-1],tree,branch);
  };
break;
case ITREE:
  sign = -1;
  if(tree[r-1] > pe){
  m = 0;
/*  for(i=0,j=nbuf-1;(nbuf>0)&&(j>i);){
    k = (i+j)/2;
*/
   for(k=0;k<nbuf;k++){
/*    printf("search i,j,k=%d, %d, %d\n",i,j,k);*/
  for(n=r-1; n > 0; n--){
/*  printf("k,n,treebuf[k][n],tree[n]=%d %d %d %d\n",k,n,treebuf[k][n],tree[n]); */
  if(treebuf[k][n] > tree[n]){
  j = k;
  m = 0;
  break;}
  else
  if(treebuf[k][n] < tree[n]){
  i = k;
  m = 0;
  break;}
  m = 1;
  };
  if( (n == 0) && (m == 1) ){break;};
  };
  if(m == 0){
  printf("unmatched Itree(not in common tree): ");
print_tree(r-1,((treecheck(r-1,tree,d1,d2) == 1)?1:-1),tree,branch);
  return;
  };
  sign = 1;
  for(i=1; i < r; i++){
  if(tree[i] > pe){
  if(treebufd1[k][i] != d1[tree[i]])sign = sign*(-1);
/*  if(treebufd2[k][i] != d2[tree[i]])sign = sign*(-1);  */
    for(j=i+1;j<r;j++){
       if(treebufd1[k][j] == d1[tree[i]]){
       tmp = treebufd1[k][j];
       treebufd1[k][j] = treebufd1[k][i];
       treebufd1[k][i] = tmp;
       };
    };
  };
  };
  sign = sign * treesign[k] * ((treecheck(r-1,tree,d1,d2) == 1)?1:-1);
  };
print_tree(r-1,sign,tree,branch);
break;
};

}




void minty(n,e,r,d1,d2,v,vstk,estk,edge,tree,branch,pe,pass)
int e,n,r,pe,pass,d1[],d2[],v[],edge[],vstk[][NMAX],
   estk[][EMAX],tree[];
char branch[][8];
{
int vd1,vd2,i,j,k,l,m,it,nt;
for(k=1;k <= e;k++)edge[k] = 1;
for(k=1;k <= n;k++)v[k] = 0;
it = 0;
i = 1;
nt = 0;
L15:
for(k=1;(k <= e);k++)if(edge[k] == 1)goto L40;
L25:
if(it == 1)return;
it--;
for(k=1;k <= e;k++)edge[k] = estk[it][k];
for(k=1,i = 0;k <= n;k++){v[k] = vstk[it][k];if(v[k] > i)i = v[k];};
i++;
goto L15;

L40:
l = k;
edge[l] = 0;
m = 0;
for(k=1;k <= e;k++)if(edge[k] != 0)m++;
if( m >= (n - 1))
{
for(k=1;k <= e;k++)estk[it][k] = edge[k];
for(k=1;k <= n;k++)vstk[it][k] = v[k];
it++;
}
L60:
edge[l] = -1;
vd1 = d1[l];
vd2 = d2[l];

if(v[vd1] == 0)goto L95;
if(v[vd2] == 0)goto L105;

l = v[vd1];
m = v[vd2];

if(l == m)goto L25;
if(l > m){k = m;m = l;l = k;};
for(k = 1;k <= n;k++){
if(v[k] > m)
 v[k]--;
else
 if(v[k] == m)
  v[k] = l;
};
i--;
goto L110;
L95:
if(v[vd2] == 0)goto L100;
v[vd1] = v[vd2];
goto L110;
L100:
v[vd1] = i;
v[vd2] = i;
i++;
goto L15;
L105:
v[vd2] = v[vd1];
L110:
for(k = 1;k <= n;k++)if(v[k] != 1)goto L15;
nt++;
l = 1;
for(k = 2;k <= e;k++) /* dummy edge 1 is always present, so skip it */
 if(edge[k] == -1){tree[l] = k;l++;};
/* printf(" Tree no. %3d\n\r",nt); */
/* for(k = 1;k <= r;k++)printf(" %2d ",tree[k]);
printf("\n\r"); */
product(r,tree,branch,d1,d2,pe,pass);
goto L25;

}
