/*tree6.txt-- maeyeda's 2-tree method to evaluate topological formulas using
   (minty's algorithm for spanning tree enumeration
   in symbolic network analysis, lin) */

#include <stdio.h>
#define actmax 10		/* max active 4-ports */
#define emax (40+actmax)	/* max edges */
#define nmax 20			/* max nodes */
#define stk1 nmax		/* minty alg. stack */
#define stk2 nmax		/* traverse stack */
#define tbuf1max 1500		/*v-tree  list to match i-trees */
#define tbuf2max 1500
#define vtree 1
#define itree 2
int treebuf[tbuf1max][nmax];
int treepermbuf[tbuf1max][nmax];
int nbuf;
int treebuf2[tbuf2max][nmax], branchtag[emax];
int nbuf2, dtag;

main()
{
    int e, n, r, a, act, d1[emax], d2[emax], d3[actmax], d4[actmax],
     v[nmax], edge[emax], vstk[stk1][nmax], estk[stk1][emax], tree[nmax],
     vd1, vd2, i, j, scan;
    char branch[emax][8];

    e = 1;			/* first edge is always dummy */
    n = 0;
    a = 0;
    act = 0;

    for (scan = 1; scan == 1;) {
/*printf("scanloop e= %d\r\n",e); */
	scanf("%s %u %u", &branch[e + 1][0], &d1[e + 1], &d2[e + 1]);
/*printf("%s,%u,%u\n\r",&branch[e+1][0],d1[e+1],d2[e+1]); */
	if ((branch[e + 1][0] == 'k') || (branch[e + 1][0] == 'K') ||
	    (branch[e + 1][0] == 'm') || (branch[e + 1][0] == 'M') ||
	    (branch[e + 1][0] == 'f') || (branch[e + 1][0] == 'F')) {
	    scanf(" %u %u", &d3[a + 1], &d4[a + 1]);
	    e++;
	    if (d1[e] > n)
		n = d1[e];
	    if (d2[e] > n)
		n = d2[e];
	    a++;
	    if (d3[a] > n)
		n = d3[a];
	    if (d4[a] > n)
		n = d4[a];
	} else {
	    e++;
	    if (d1[e] > n)
		n = d1[e];
	    if (d2[e] > n)
		n = d2[e];
	};
	if ((branch[e][0] == 'f') || (branch[e][0] == 'F')) {
/* dummy edge (handle) and extra node */
	    d1[1] = n + 1;
	    d2[1] = 1;
	    branch[1][0] = 'x';
	    branch[1][1] = 0;
	    n++;
	    scan = 0;
	};
    } e = e - a;
    r = n - 1;

#if 0

    printf(" Function:\n");
    printf("e= %d, a=%d, n=%d\n", e, a, n);
    for (i = 1; i <= e; i++) {
	printf("%s,%d,%d\n", &branch[i][0], d1[i], d2[i]);
    };
    for (i = 1; i <= a; i++) {
	printf("%s,%d,%d,%d,%d\n", &branch[i + e][0], d1[i + e], d2[i + e], d3[i], d4[i]);
    };
    e = e - a;
    r = n - 1;

    printf("driving point admittance function yi(%d, %d):\n", d1[e + a], d2[e + a]);
    printf("\n Numerator:\n\n");
/*printf("vtree--\n"); */
    nbuf = 0;
    nbuf2 = 0;
    for (i = 0; i <= (e + a); i++)
	branchtag[i] = 0;
    minty(n, (e + a), r, d1, d2, v, vstk, estk, edge, tree, branch, e, vtree, 0);

    for (i = 1; i < a; i++) {
	j = d1[e + i];
	d1[e + i] = d3[i];
	d3[i] = j;
	j = d2[e + i];
	d2[e + i] = d4[i];
	d4[i] = j;
    };
    j = d2[e + a];
    d2[e + a] = d1[e + a];
    d1[e + a] = j;
/*printf("itree--\n"); */

    minty(n, (e + a), r, d1, d2, v, vstk, estk, edge, tree, branch, e, itree, 1);

/*printf("\n Denominator:\n\n"); */
/*restore original order */
    for (i = 1; i < a; i++) {
	j = d1[e + i];
	d1[e + i] = d3[i];
	d3[i] = j;
	j = d2[e + i];
	d2[e + i] = d4[i];
	d4[i] = j;
    };
    j = d2[e + a];
    d2[e + a] = d1[e + a];
    d1[e + a] = j;

/*printf("vtree--\n"); */

    nbuf = 0;
    dtag = nbuf2 + 1;
    minty(n, (e + a), r, d1, d2, v, vstk, estk, edge, tree, branch, e, vtree, 1);


    for (i = 1; i < a; i++) {
	j = d1[e + i];
	d1[e + i] = d3[i];
	d3[i] = j;
	j = d2[e + i];
	d2[e + i] = d4[i];
	d4[i] = j;
    };
    j = d2[e + a];
    d2[e + a] = d1[e + a];
    d1[e + a] = j;
/*printf("itree--\n"); */

    minty(n, (e + a), r, d1, d2, v, vstk, estk, edge, tree, branch, e, itree, 0);
    print_treebuf2((e + a), branch, 0);

    printf("\n End: \n\n");

/*restore original order */
    for (i = 1; i < a; i++) {
	j = d1[e + i];
	d1[e + i] = d3[i];
	d3[i] = j;
	j = d2[e + i];
	d2[e + i] = d4[i];
	d4[i] = j;
    };
    j = d2[e + a];
    d2[e + a] = d1[e + a];
    d1[e + a] = j;
#endif

#if 1

    printf("\n Function:\n");
    printf("e= %d, a=%d, n=%d\n", e, a, n);
    for (i = 1; i <= e; i++) {
	printf("%s,%d,%d\n", &branch[i][0], d1[i], d2[i]);
    };
    for (i = 1; i <= a; i++) {
	printf("%s,%d,%d,%d,%d\n", &branch[i + e][0], d1[i + e], d2[i + e], d3[i], d4[i]);
    };

    printf("voltage transfer function vi(%d, %d), vo(%d, %d):\n", d1[e + a], d2[e + a], d3[a], d4[a]);
    printf("\n Numerator:\n\n");
/*printf("vtree--\n"); */

    nbuf = 0;
    nbuf2 = 0;
    for (i = 0; i <= (e + a); i++)
	branchtag[i] = 0;
    j = d1[e + a];
    d1[e + a] = d3[a];
    d3[a] = j;
    j = d2[e + a];
    d2[e + a] = d4[a];
    d4[a] = j;
    minty(n, (e + a), r, d1, d2, v, vstk, estk, edge, tree, branch, e, vtree, 0);

    for (i = 1; i <= a; i++) {
	j = d1[e + i];
	d1[e + i] = d3[i];
	d3[i] = j;
	j = d2[e + i];
	d2[e + i] = d4[i];
	d4[i] = j;
    };
/*printf("itree--\n"); */

    minty(n, (e + a), r, d1, d2, v, vstk, estk, edge, tree, branch, e, itree, 0);

/*printf("\n Denominator:\n\n"); */
/*restore original order */
    for (i = 1; i < a; i++) {
	j = d1[e + i];
	d1[e + i] = d3[i];
	d3[i] = j;
	j = d2[e + i];
	d2[e + i] = d4[i];
	d4[i] = j;
    };
/*printf("vtree--\n"); */

    nbuf = 0;
    dtag = nbuf2 + 1;
    minty(n, (e + a), r, d1, d2, v, vstk, estk, edge, tree, branch, e, vtree, 1);

    for (i = 1; i < a; i++) {
	j = d1[e + i];
	d1[e + i] = d3[i];
	d3[i] = j;
	j = d2[e + i];
	d2[e + i] = d4[i];
	d4[i] = j;
    };
    j = d2[e + a];
    d2[e + a] = d1[e + a];
    d1[e + a] = j;

/*printf("itree--\n"); */
    minty(n, (e + a), r, d1, d2, v, vstk, estk, edge, tree, branch, e, itree, 0);
    print_treebuf2((e + a), branch, 0);

    printf("\n End: \n\n");

#endif
}
collect_tree(r, sign, tree, branch, q)
int r, sign, q, tree[];
char branch[][8];
{
/* branchtag collects all the impedance-unit factors to be divided out later */
    int s, i, f;

/*printf("<");
   for(i = 1;i <= r;i++) {
   if ( (branch[tree[i]][0] == 'f') && (q < 3)  )continue;
   printf(" %s",&branch[tree[i]][0]);
   }
   printf(">\n"); */
    s = 0;
    f = 0;
    for (i = 1; i <= r; i++) {
	if (branch[tree[i]][0] == 'f')
	    f = 1;
	if (branch[tree[i]][0] == 'F')
	    f = 1;
    } if ((q == 0) || (q == 1))
	if (q == f)
	    return;
    if (nbuf2 >= (tbuf2max - 1)) {
	printf("treebuf2 is full\n");
	return;
    };
    nbuf2++;
    treebuf2[nbuf2][0] = (sign == 1) ? r : (-r);
    for (i = 1; i <= r; i++) {
	if ((branch[tree[i]][0] == 'r') ||
	    (branch[tree[i]][0] == 'R') ||
	    (branch[tree[i]][0] == 'l') ||
	    (branch[tree[i]][0] == 'L') ||
	    (branch[tree[i]][0] == 'm') ||
	    (branch[tree[i]][0] == 'M'))
	    branchtag[tree[i]] = 1;
	treebuf2[nbuf2][i] = tree[i];
    }
}
print_treebuf2(n, branch, q)
int n, q;
char branch[][8];
{
    int s, i, j, k, r, f, tmptree[emax];

/*printf("nbuf2=%d, dtag=%d\n",nbuf2,dtag); */
    for (i = 1; i <= nbuf2; i++) {
	if (i == dtag)
	    printf("\n Denominator:\n\n");

	r = treebuf2[i][0];
	r = (r > 0) ? r : (-r);
	for (j = 1; j <= n; j++)
	    tmptree[j] = 0;

	for (j = 1; j <= r; j++)
	    tmptree[treebuf2[i][j]] = 1;
/* (branchtag == tmptree == 0) means no factor in tree or cancellation list
   (branchtag == tmptree == 1) means the factor in tree is cancelled by cancellation list
   (branchtag != tmptree) means factor is due to either tree or cancellation list */
	for (j = 1; j <= n; j++)
	    if (branchtag[j] == tmptree[j])
		tmptree[j] = 0;
	    else
		tmptree[j] = 1;
/*if(i<dtag){
   printf("**");
   for (j=1;j<=n;j++)printf("%1d",tmptree[j]);
   printf("\n");
   }; */
	s = 0;
	f = 0;
	for (j = 1; j <= n; j++) {
	    if (tmptree[j] == 0)
		continue;
	    k = branch[j][0];
	    if (k == 'c')
		s++;
	    if (k == 'C')
		s++;
	    if (k == 'm')
		s++;
	    if (k == 'M')
		s++;
	    if (k == 'l')
		s++;
	    if (k == 'L')
		s++;
	    if (k == 'f')
		f = 1;
	    if (k == 'F')
		f = 1;
	} printf(" %s s%d", (treebuf2[i][0] > 0) ? "+" : "-", s);
	for (j = 1; j <= n; j++) {
	    if (tmptree[j] == 0)
		continue;
	    if (((branch[j][0] == 'f') || (branch[j][0] == 'F')) && (q < 3))
		continue;
	    printf(" %s", &branch[j][0]);
	} printf("\n");
    }
}
print_tree(r, sign, tree, branch, q)
int r, sign, q, tree[];
char branch[][8];
{
    int s, i, f;

    s = 0;
    f = 0;
    for (i = 1; i <= r; i++) {
	if (branch[tree[i]][0] == 'c')
	    s++;
	if (branch[tree[i]][0] == 'C')
	    s++;
	if (branch[tree[i]][0] == 'l')
	    s--;
	if (branch[tree[i]][0] == 'L')
	    s--;
	if (branch[tree[i]][0] == 'f')
	    f = 1;
	if (branch[tree[i]][0] == 'F')
	    f = 1;
    } if ((q == 0) || (q == 1))
	if (q == f)
	    return;
    printf(" %s s%d", (sign == 1) ? "+" : "-", s);
    for (i = 1; i <= r; i++) {
	if ((branch[tree[i]][0] == 'f') && (q < 3))
	    continue;
	printf(" %s", &branch[tree[i]][0]);
    } printf("\n");
}
treecheck(r, pe, tree, d1, d2, perm, branch)
int r, pe, tree[], d1[], d2[], perm[];
char branch[][8];
{
    int stack[nmax], tag[nmax];
    int depth, i, j, done, root_node, princip_node;

/*printf("treecheck, r=%d\n",r); */
    for (i = 1; i <= r; i++) {
	tag[i] = 0;
/*printf("%s %d d1=%d, d2=%d\n",&branch[tree[i]][0],tree[i],d1[tree[i]],d2[tree[i]]); */
    };
/*printf("\n"); */

    perm[0] = 0;
    perm[1] = 0;
    stack[0] = 1;
    depth = 0;
    for (done = 0; done == 0;) {
	root_node = stack[depth];
	for (i = 1; i <= r; i++) {
	    if (tag[i] == 1)
		continue;
	    if (d1[tree[i]] == root_node) {
		tag[i] = 1;
		princip_node = d2[tree[i]];
		perm[princip_node] = tree[i];
		break;
	    };
	    if (d2[tree[i]] == root_node) {
		tag[i] = 1;
		princip_node = d1[tree[i]];
		perm[princip_node] = (tree[i] > pe) ? (-tree[i]) : tree[i];
		break;
	    };
	};
	if (i <= r) {
	    depth++;
	    stack[depth] = princip_node;
	} else {
	    if (depth > 0)
		depth--;
	    else
		done = 1;
	};
    };
/*printf("permutation list:\n");
   for(i=0; i<=r+1;i++){
   printf("%3d ",perm[i]);
   };
   printf("\n"); */
    return;
}
product(r, tree, branch, d1, d2, pe, pass, f)
int r, pass, pe, d1[], d2[], tree[], f;
char branch[][8];
{
    int i, j, k, m, n, s, sign, tmp, permbuf[nmax];

    switch (pass) {
    case vtree:
	if (tree[r - 1] > pe) {
	    if (nbuf >= (tbuf1max - 1)) {
		printf("treebuf is full\n");
		return;
	    };
	    for (i = 1; i < r; i++) {
		treebuf[nbuf][i] = tree[i];
	    };
	    treecheck(r - 1, pe, tree, d1, d2, &treepermbuf[nbuf][0], branch);
	    nbuf++;
/*  printf("buffered vtree:\n");
   print_tree(r-1,1,tree,branch,3);  */
	};
	break;
    case itree:
	sign = 1;
	if (tree[r - 1] > pe) {
	    m = 0;
/*  for(i=0,j=nbuf-1;(nbuf>0)&&(j>i);)
   k = (i+j)/2;
 */
	    for (k = 0; k < nbuf; k++) {
/*    printf("search i,j,k=%d, %d, %d\n",i,j,k); */
		for (n = r - 1; n > 0; n--) {
/*  printf("k,n,treebuf[k][n],tree[n]=%d %d %d %d\n",k,n,treebuf[k][n],tree[n]); */
		    if (treebuf[k][n] > tree[n]) {
			j = k;
			m = 0;
			break;
		    } else if (treebuf[k][n] < tree[n]) {
			i = k;
			m = 0;
			break;
		    }
		    m = 1;
		};
		if ((n == 0) && (m == 1)) {
		    break;
		};
	    };
	    if (m == 0) {
/*  printf("unmatched itree(not in common tree): ");
   print_tree(r-1,1,tree,branch,3); */
		return;
	    };
	    sign = 1;
	    treecheck(r - 1, pe, tree, d1, d2, &permbuf[0], branch);
/*printf("product:\n");
   printf("v- ");
   for(i=0;i<=r;i++){
   printf("%3d ",permbuf[i]);
   };printf("\n");
   printf("i- ");
   for(i=0;i<=r;i++){
   printf("%3d ",treepermbuf[k][i]);
   };printf("\n"); */
/* capture the principal node component of the sign computation */
	    for (i = 2; i <= r; i++) {
		if (treepermbuf[k][i] < 0) {
		    sign = sign * (-1);
		    treepermbuf[k][i] = (-treepermbuf[k][i]);
		};
		if (permbuf[i] < 0) {
		    sign = sign * (-1);
		    permbuf[i] = (-permbuf[i]);
		};
	    };
/*printf("sign1= %2d\n",sign); */
/* capture the permutation component of the sign computation */
	    for (i = 2; i <= r; i++) {
						/*if(tree[i] > pe) */  {
						/*expect no permutation for the passive part */
		    if (treepermbuf[k][i] != permbuf[i]) {
			sign = sign * (-1);
			for (j = i + 1; j <= r; j++) {
			    if (treepermbuf[k][j] == permbuf[i]) {
				tmp = treepermbuf[k][j];
				treepermbuf[k][j] = treepermbuf[k][i];
				treepermbuf[k][i] = tmp;
				break;
			    };
			};
		    };
		};
	    };
/*for(i=0;i<=r;i++){
   printf("%3d ",permbuf[i]);
   };printf("\n");
   for(i=0;i<=r;i++){
   printf("%3d ",treepermbuf[k][i]);
   };printf("\n");

   printf("sign2= %2d\n",sign); */
	};
	collect_tree(r - 1, sign, tree, branch, f);
	break;
    };

}
minty(n, e, r, d1, d2, v, vstk, estk, edge, tree, branch, pe, pass, f)
int e, n, r, pe, pass, d1[], d2[], v[], edge[], vstk[][nmax], estk[][emax],
 tree[], f;
char branch[][8];
{
    int vd1, vd2, i, j, k, l, m, it, nt;

/* printf("e,n,r,pe,pass=%d %d %d %d %d\n",e,n,r,pe,pass); */
    for (k = 1; k <= e; k++)
	edge[k] = 1;
    for (k = 1; k <= n; k++)
	v[k] = 0;
    it = 0;
    i = 1;
    nt = 0;
  l15:
    for (k = 1; (k <= e); k++)
	if (edge[k] == 1)
	    goto l40;
  l25:
/*printf("it=%d\n",it); */
    if (it <= 1)
	return;
    it--;
    for (k = 1; k <= e; k++)
	edge[k] = estk[it][k];
    for (k = 1, i = 0; k <= n; k++) {
	v[k] = vstk[it][k];
	if (v[k] > i)
	    i = v[k];
    };
/*printf("pop stack: edge=");
   for(k=1;k <= e;k++)printf("%d,",edge[k]);
   printf("\nvertex=");
   for(k=1;k <= n;k++)printf("%d,",v[k]);
   printf("\n"); */
    i++;
    goto l15;

  l40:
    l = k;
    edge[l] = 0;
    m = 0;
    for (k = 1; k <= e; k++)
	if (edge[k] != 0)
	    m++;
    if (m >= (n - 1)) {
/*printf("push\n"); */

	for (k = 1; k <= e; k++)
	    estk[it][k] = edge[k];
	for (k = 1; k <= n; k++)
	    vstk[it][k] = v[k];
	it++;
    }
  l60:
    edge[l] = -1;
    vd1 = d1[l];
    vd2 = d2[l];

    if (v[vd1] == 0)
	goto l95;
    if (v[vd2] == 0)
	goto l105;

    l = v[vd1];
    m = v[vd2];

    if (l == m)
	goto l25;
    if (l > m) {
	k = m;
	m = l;
	l = k;
    };
    for (k = 1; k <= n; k++) {
	if (v[k] > m)
	    v[k]--;
	else if (v[k] == m)
	    v[k] = l;
    };
    i--;
    goto l110;
  l95:
    if (v[vd2] == 0)
	goto l100;
    v[vd1] = v[vd2];
    goto l110;
  l100:
    v[vd1] = i;
    v[vd2] = i;
    i++;
    goto l15;
  l105:
    v[vd2] = v[vd1];
  l110:
    for (k = 1; k <= n; k++)
	if (v[k] != 1)
	    goto l15;
    nt++;
    l = 1;
    for (k = 2; k <= e; k++)	/* dummy edge 1 is always present, so skip it */
	if (edge[k] == -1) {
	    tree[l] = k;
	    l++;
	};
/* printf(" tree no. %3d\n",nt); 
   for(k = 1;k < r;k++)printf(" %2d ",tree[k]);
   printf("\n"); */
    product(r, tree, branch, d1, d2, pe, pass, f);
    goto l25;

}
